! ++++++++++++++++++++++++++++++++++++++++++++++++++++++
!
!  MIDAS procedure verify15.prg  to verify MIDAS commands
!  for long filenames
! 
!  K. Banse     060222
!
!  use as @@ verify15 ffffffffff             with f = 1 or 0 (on/off)
!
! 060830	last modif
! ++++++++++++++++++++++++++++++++++++++++++++++++++++++
!
define/par p1 1111111111 n "Enter control flags for entries: "
!
define/local loop/i/1/1 0
define/local rval/r/1/1 0. ? +lower
define/local ival/i/1/5 0 all +lower
define/local seconds/i/1/2 0,0 ? +lower
define/local rcorr/r/1/20 0. all +lower
define/local icorr/i/1/20 0 all +lower
define/local errsum/i/1/1 0 ? +lower
define/local ccc/c/1/10 0000000000
define/local secs/i/1/2 0,0 ? +lower
define/local myvals/i/1/2 0,0 ? +lower
define/local longdir1/c/1/60 verylongdirectoryforfilestotestmidas ? +lower
define/local longdir2/c/1/60 anotherverylongdirectoryforfilestotestmidas ? +lower
!
delete/temp                             !get rid of old temporary files
! 
write/key sizez/i/1/5 600,600,0,0,0
write/key dispyes/i/1/2 0,0
write/key stop/i/1/1 0
!
write/out +------------------------------------------+
write/out Start of procedure verify15.prg
write/out +------------------------------------------+
!
seconds(1) = m$secs()
write/key ccc {p1}
set/format i1
do loop = 1 6
   if ccc({loop}:{loop}) .eq. "1" @@ verify15,000{loop}
   if errsum .gt. 0 then
      write/out "We got problems with entry 000{loop} in verify15.prg!"
      stop = 1
      return
   endif
enddo
seconds(2) = m$secs()
mid$info(8) = seconds(2)-seconds(1)
! 
! we have to execute this entry after all others, because all local
! keywords disappear after SET/MIDAS keyw=...
! 
@@ verify15,last
!
write/out +------------------------------------------+
write/out procedure verify15.prg:
write/out Total time elapsed = {mid$info(8)} seconds.
write/out All tests o.k. - you deserve a coffee now...
write/out +------------------------------------------+
!
!  here the different sub-procedures
!
entry 0001
!
if aux_mode(1) .lt. 2 return
! 
write/out create subdirs with long names
write/out "------------------------------"
! 
open/file makelongdir.sh write inputi
write/file {inputi} "#!/bin/sh "
write/file {inputi} "mkdir {longdir1}"
write/file {inputi} "cd ./{longdir1}"
write/file {inputi} "mkdir {longdir2}"
write/file {inputi} "cd ./{longdir2}"
write/file {inputi} "echo now in `pwd`"
write/file {inputi} "cp ../../wcstest.mt ."
close/file {inputi}
! 
$ cat ./makelongdir.sh
$ chmod +x ./makelongdir.sh
$ ./makelongdir.sh
!
entry 0002
!
write/out test of loooooooong filenames
write/out "-----------------------------"
! 
$ rm -f middummz*
write/out > copy/ii LONG_FILE_NAME &z
copy/ii ./{longdir1}/{longdir2}/wcstest.mt &z
if m$exist("middummz.bdf") .ne. 1 then
   write/out problems with copy/ii
   errsum = errsum + 1
   return
endif
! 
write/out > copy/dk LONG_FILE_NAME  npix outputi
copy/dk ./{longdir1}/{longdir2}/wcstest.mt npix outputi
if outputi(1) .ne. 353 .or. outputi(2) .ne. 353 then
   write/out problems with copy/dk
   errsum = errsum + 1
   return
endif
! 
write/out > read/descr LONG_FILE_NAME
read/descr ./{longdir1}/{longdir2}/wcstest.mt 
! 
write/out > fft/image LONG_FILE_NAME
fft/image ./{longdir1}/{longdir2}/wcstest.mt 
! 
write/keyw rcorr  2.981000e+03,1.395000e+04
write/out > statistics/image LONG_FILE_NAME 
statist/image ./{longdir1}/{longdir2}/wcstest.mt 
@@ kcompare rcorr outputr 1,2 0.3
!
entry 0003
!
write/out test of erroneous ESO descriptors in FITS file
write/out "----------------------------------------------"
! 
indisk/fits F1_PZPI_050103A_VBE_fhis.tfits eso-descr
if m$exist("eso-descr.tbl") .ne. 1 then
   write/out problems with reading faulty ESO descriptors from FITS header"
   errsum = errsum + 1
   return
endif
! 
entry 0004
!
write/out test of statistics like STATIST/IMA on table column
write/out "---------------------------------------------------"
! 
statistics/image hear.tbl,:wave
write/keyw rcorr/r/8/2  5641.88,3653.93 
@@ kcompare rcorr outputr 8,2 0.05
! 
entry 0005
!
write/out test of LOAD/TABLE
write/out "------------------"
! 
reset/display
create/display 7 512,512,616,300 p5=40000	!lots of drawing...
dispyes(1) = 1					!mark that we have display 
load/lut heat
! 
write/out > load/image order.fits scale=-3
load/image order.fits scale=-3
write/out > load/table order.tfits :x :y :order 0 0 4
load/table order.tfits :x :y :order 0 0 4
! 
entry 0006
!
write/out test of creating big images 
write/out "---------------------------"
! 
$rm -f xbig.big
define/local inni/i/1/1 800
if mid$sys(1:10) .eq. "PC/Linux64" inputi = 2000
write/out > create/image xbig.big 3,1000,1000,{inni} ? ? 27 ui2
@a snail
create/image xbig.big 3,1000,1000,{inni} ? ? 27 ui2
$ls -l xbig.big
read/descr xbig.big
read/image xbig.big
$rm -f xbig.big
!
entry 0007
!
entry last
!
write/out test of extending keyword area
write/out "------------------------------"
! 
set/midas keywords=??
outputi(1) = outputi(1) + 100
outputi(2) = outputi(2) + 200
set/midas keywords={outputi},{outputi(2)}
set/midas keywords=?
! 



